// Copyright 2020 the Pinniped contributors. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"time"

	v1alpha1 "go.pinniped.dev/generated/1.17/apis/idp/v1alpha1"
	scheme "go.pinniped.dev/generated/1.17/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// OpenIDConnectIdentityProvidersGetter has a method to return a OpenIDConnectIdentityProviderInterface.
// A group's client should implement this interface.
type OpenIDConnectIdentityProvidersGetter interface {
	OpenIDConnectIdentityProviders(namespace string) OpenIDConnectIdentityProviderInterface
}

// OpenIDConnectIdentityProviderInterface has methods to work with OpenIDConnectIdentityProvider resources.
type OpenIDConnectIdentityProviderInterface interface {
	Create(*v1alpha1.OpenIDConnectIdentityProvider) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	Update(*v1alpha1.OpenIDConnectIdentityProvider) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	UpdateStatus(*v1alpha1.OpenIDConnectIdentityProvider) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	Delete(name string, options *v1.DeleteOptions) error
	DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error
	Get(name string, options v1.GetOptions) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	List(opts v1.ListOptions) (*v1alpha1.OpenIDConnectIdentityProviderList, error)
	Watch(opts v1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.OpenIDConnectIdentityProvider, err error)
	OpenIDConnectIdentityProviderExpansion
}

// openIDConnectIdentityProviders implements OpenIDConnectIdentityProviderInterface
type openIDConnectIdentityProviders struct {
	client rest.Interface
	ns     string
}

// newOpenIDConnectIdentityProviders returns a OpenIDConnectIdentityProviders
func newOpenIDConnectIdentityProviders(c *IDPV1alpha1Client, namespace string) *openIDConnectIdentityProviders {
	return &openIDConnectIdentityProviders{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the openIDConnectIdentityProvider, and returns the corresponding openIDConnectIdentityProvider object, and an error if there is any.
func (c *openIDConnectIdentityProviders) Get(name string, options v1.GetOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of OpenIDConnectIdentityProviders that match those selectors.
func (c *openIDConnectIdentityProviders) List(opts v1.ListOptions) (result *v1alpha1.OpenIDConnectIdentityProviderList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.OpenIDConnectIdentityProviderList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested openIDConnectIdentityProviders.
func (c *openIDConnectIdentityProviders) Watch(opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a openIDConnectIdentityProvider and creates it.  Returns the server's representation of the openIDConnectIdentityProvider, and an error, if there is any.
func (c *openIDConnectIdentityProviders) Create(openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Body(openIDConnectIdentityProvider).
		Do().
		Into(result)
	return
}

// Update takes the representation of a openIDConnectIdentityProvider and updates it. Returns the server's representation of the openIDConnectIdentityProvider, and an error, if there is any.
func (c *openIDConnectIdentityProviders) Update(openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(openIDConnectIdentityProvider.Name).
		Body(openIDConnectIdentityProvider).
		Do().
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().

func (c *openIDConnectIdentityProviders) UpdateStatus(openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(openIDConnectIdentityProvider.Name).
		SubResource("status").
		Body(openIDConnectIdentityProvider).
		Do().
		Into(result)
	return
}

// Delete takes name of the openIDConnectIdentityProvider and deletes it. Returns an error if one occurs.
func (c *openIDConnectIdentityProviders) Delete(name string, options *v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *openIDConnectIdentityProviders) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched openIDConnectIdentityProvider.
func (c *openIDConnectIdentityProviders) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
