// Copyright 2020 the Pinniped contributors. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "go.pinniped.dev/generated/1.18/apis/idp/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeOpenIDConnectIdentityProviders implements OpenIDConnectIdentityProviderInterface
type FakeOpenIDConnectIdentityProviders struct {
	Fake *FakeIDPV1alpha1
	ns   string
}

var openidconnectidentityprovidersResource = schema.GroupVersionResource{Group: "idp.pinniped.dev", Version: "v1alpha1", Resource: "openidconnectidentityproviders"}

var openidconnectidentityprovidersKind = schema.GroupVersionKind{Group: "idp.pinniped.dev", Version: "v1alpha1", Kind: "OpenIDConnectIdentityProvider"}

// Get takes name of the openIDConnectIdentityProvider, and returns the corresponding openIDConnectIdentityProvider object, and an error if there is any.
func (c *FakeOpenIDConnectIdentityProviders) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(openidconnectidentityprovidersResource, c.ns, name), &v1alpha1.OpenIDConnectIdentityProvider{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OpenIDConnectIdentityProvider), err
}

// List takes label and field selectors, and returns the list of OpenIDConnectIdentityProviders that match those selectors.
func (c *FakeOpenIDConnectIdentityProviders) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.OpenIDConnectIdentityProviderList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(openidconnectidentityprovidersResource, openidconnectidentityprovidersKind, c.ns, opts), &v1alpha1.OpenIDConnectIdentityProviderList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.OpenIDConnectIdentityProviderList{ListMeta: obj.(*v1alpha1.OpenIDConnectIdentityProviderList).ListMeta}
	for _, item := range obj.(*v1alpha1.OpenIDConnectIdentityProviderList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested openIDConnectIdentityProviders.
func (c *FakeOpenIDConnectIdentityProviders) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(openidconnectidentityprovidersResource, c.ns, opts))

}

// Create takes the representation of a openIDConnectIdentityProvider and creates it.  Returns the server's representation of the openIDConnectIdentityProvider, and an error, if there is any.
func (c *FakeOpenIDConnectIdentityProviders) Create(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.CreateOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(openidconnectidentityprovidersResource, c.ns, openIDConnectIdentityProvider), &v1alpha1.OpenIDConnectIdentityProvider{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OpenIDConnectIdentityProvider), err
}

// Update takes the representation of a openIDConnectIdentityProvider and updates it. Returns the server's representation of the openIDConnectIdentityProvider, and an error, if there is any.
func (c *FakeOpenIDConnectIdentityProviders) Update(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.UpdateOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(openidconnectidentityprovidersResource, c.ns, openIDConnectIdentityProvider), &v1alpha1.OpenIDConnectIdentityProvider{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OpenIDConnectIdentityProvider), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeOpenIDConnectIdentityProviders) UpdateStatus(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.UpdateOptions) (*v1alpha1.OpenIDConnectIdentityProvider, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(openidconnectidentityprovidersResource, "status", c.ns, openIDConnectIdentityProvider), &v1alpha1.OpenIDConnectIdentityProvider{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OpenIDConnectIdentityProvider), err
}

// Delete takes name of the openIDConnectIdentityProvider and deletes it. Returns an error if one occurs.
func (c *FakeOpenIDConnectIdentityProviders) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(openidconnectidentityprovidersResource, c.ns, name), &v1alpha1.OpenIDConnectIdentityProvider{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeOpenIDConnectIdentityProviders) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(openidconnectidentityprovidersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.OpenIDConnectIdentityProviderList{})
	return err
}

// Patch applies the patch and returns the patched openIDConnectIdentityProvider.
func (c *FakeOpenIDConnectIdentityProviders) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(openidconnectidentityprovidersResource, c.ns, name, pt, data, subresources...), &v1alpha1.OpenIDConnectIdentityProvider{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.OpenIDConnectIdentityProvider), err
}
