// Copyright 2020 the Pinniped contributors. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "go.pinniped.dev/generated/1.19/apis/idp/v1alpha1"
	scheme "go.pinniped.dev/generated/1.19/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// OpenIDConnectIdentityProvidersGetter has a method to return a OpenIDConnectIdentityProviderInterface.
// A group's client should implement this interface.
type OpenIDConnectIdentityProvidersGetter interface {
	OpenIDConnectIdentityProviders(namespace string) OpenIDConnectIdentityProviderInterface
}

// OpenIDConnectIdentityProviderInterface has methods to work with OpenIDConnectIdentityProvider resources.
type OpenIDConnectIdentityProviderInterface interface {
	Create(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.CreateOptions) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	Update(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.UpdateOptions) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	UpdateStatus(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.UpdateOptions) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.OpenIDConnectIdentityProvider, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.OpenIDConnectIdentityProviderList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.OpenIDConnectIdentityProvider, err error)
	OpenIDConnectIdentityProviderExpansion
}

// openIDConnectIdentityProviders implements OpenIDConnectIdentityProviderInterface
type openIDConnectIdentityProviders struct {
	client rest.Interface
	ns     string
}

// newOpenIDConnectIdentityProviders returns a OpenIDConnectIdentityProviders
func newOpenIDConnectIdentityProviders(c *IDPV1alpha1Client, namespace string) *openIDConnectIdentityProviders {
	return &openIDConnectIdentityProviders{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the openIDConnectIdentityProvider, and returns the corresponding openIDConnectIdentityProvider object, and an error if there is any.
func (c *openIDConnectIdentityProviders) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of OpenIDConnectIdentityProviders that match those selectors.
func (c *openIDConnectIdentityProviders) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.OpenIDConnectIdentityProviderList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.OpenIDConnectIdentityProviderList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested openIDConnectIdentityProviders.
func (c *openIDConnectIdentityProviders) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a openIDConnectIdentityProvider and creates it.  Returns the server's representation of the openIDConnectIdentityProvider, and an error, if there is any.
func (c *openIDConnectIdentityProviders) Create(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.CreateOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openIDConnectIdentityProvider).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a openIDConnectIdentityProvider and updates it. Returns the server's representation of the openIDConnectIdentityProvider, and an error, if there is any.
func (c *openIDConnectIdentityProviders) Update(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.UpdateOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(openIDConnectIdentityProvider.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openIDConnectIdentityProvider).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *openIDConnectIdentityProviders) UpdateStatus(ctx context.Context, openIDConnectIdentityProvider *v1alpha1.OpenIDConnectIdentityProvider, opts v1.UpdateOptions) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(openIDConnectIdentityProvider.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(openIDConnectIdentityProvider).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the openIDConnectIdentityProvider and deletes it. Returns an error if one occurs.
func (c *openIDConnectIdentityProviders) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *openIDConnectIdentityProviders) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched openIDConnectIdentityProvider.
func (c *openIDConnectIdentityProviders) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.OpenIDConnectIdentityProvider, err error) {
	result = &v1alpha1.OpenIDConnectIdentityProvider{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("openidconnectidentityproviders").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
